#!/bin/sh
#
# Restore OS depend settings after login. This solution is only a workaround to prevent webmin detect the wrong OS after update.
# Please logout and login after update to make changes.
# This script also updates the version information in the file "INFO" if webmin was not updated by a SPK.

LOG="/var/packages/webmin/log"
WMVER="`cat /var/packages/webmin/target/etc/version`"
WMINFOFILE="/var/packages/webmin/INFO"
SYNOPKGVER="`/bin/get_key_value $WMINFOFILE version | /usr/bin/cut -d '-' -f1`"
PATCHVER="`/bin/get_key_value $WMINFOFILE version | /usr/bin/cut -d '-' -f2`"

/bin/cp -f /var/packages/webmin/target/scripts/os_list.txt /var/packages/webmin/target/bin
/bin/cp -f /var/packages/webmin/target/scripts/config-synology-linux /var/packages/webmin/target/bin

if [ "$WMVER" != "$SYNOPKGVER" ] ; then
    /bin/sed "s/version=\"$SYNOPKGVER-$PATCHVER\"/version=\"$WMVER-$PATCHVER\"/" < $WMINFOFILE > $WMINFOFILE.bak
    /bin/mv -f $WMINFOFILE.bak $WMINFOFILE
    date +"%c updated to version $WMVER-$PATCHVER<br>" >> $LOG
fi
